IMPLEMENTATION MODULE FormelausFText;
(*
  Created:   30.8.87
  Changed    10.02.88/1.8.88/24.8.88 by
             Stefan Salewski
             Stolper Weg 3
             2160 Stade   West-Germany
             Tel: 04141/61130
             
  Note: compiled with AMIGA Modula-2 System by AMSoft from 5.5.88
   
  This Module may be freely copied. But please
  leave my name in. Thanks....Stefan  
*)
  FROM MyStrings IMPORT Assign;
  PROCEDURE GetFehlertext(n:CARDINAL;VAR s:ARRAY OF CHAR);
  BEGIN
    CASE n OF
      (* Fehlernummern von MyMathLibLong,MyMathTrans und Formelauswertung    *)
      0:Assign(s,'No Error; all OK')|
      3:Assign(s,'Null hoch negative Zahl ist undefiniert')|
      4:Assign(s,'Neg.Zahl hoch gebr.Zahl ist undefiniert')|
      5:Assign(s,'tan(n*Pi/2)) ist undefiniert')|
      6:Assign(s,'cot(n*Pi) ist undefiniert')|
      7:Assign(s,'sec(x) hat Pol bei x=n*Pi/2')|
      8:Assign(s,'cosec(x) hat Pol bei x=n*Pi')|
      9:Assign(s,'arcsin(x) undefiniert fuer |x|>1.0')|
      10:Assign(s,'arccos(x) undefiniert fuer |x|>1.0')|
      11:Assign(s,'exp(x) zu gross fuer x>42')|
      12:Assign(s,'ln(x) undefiniert fuer x<=0')|
      13:Assign(s,'log(x) undefiniert fuer x<=0')|
      14:Assign(s,'coth(x) hat Pol bei x=0')|
      15:Assign(s,'arcosh(x) undefiniert fuer x>1.0')|
      16:Assign(s,'artanh(x) undefiniert fuer |x|>=1.0')|
      17:Assign(s,'sqrt(x) undefiniert fuer x<0')|
      18:Assign(s,'sin,cos und tan haben die Periode 2Pi')|
      19:Assign(s,'arcoth(x) ist undefiniert fuer |x|<=1.0')|
      20:Assign(s,'int(x):nur fuer |x|<2147483648 erlaubt')|
      (* Fehlernummern fuer DefFormel *)
      31:Assign(s,'Formel ist leer')|
      32:Assign(s,'Variablen nicht initialisiert')|
      33:Assign(s,'Syntaxfehler')|
      34:Assign(s,'Formel enthaelt ungueltiges Zeichen')|
      35:Assign(s,'Formel enthaelt zu grosse Zahlen')|
      36:Assign(s,'Formel zu gross:Kann keine () setzen')|
      (* FFP Fehlernummern*)
      51:Assign(s,'FFP:fac(x) zu gross fuer x>=20')|
      52:Assign(s,'FFP:sqr(x) zu gross fuer x>=1E9')|
      53:Assign(s,'FFP:exp(x) zu gross fuer x>=42')|
      54:Assign(s,'FFP:sinh(x),cosh(x): x muss <= 42 sein')|
      (* LongReal Fehlernummern*)
      72:Assign(s,'LONGREAL:sqr(x) zu gross fuer x>=154')|
      73:Assign(s,'LONGREAL:exp(x) zu gross fuer x>710')|
      75:Assign(s,'LONGREAL:fac(x) zu gross fuer x>170') |
      76:Assign(s,'fac(x) undefiniert fuer x<0')|
      77:Assign(s,'fac(x) def nur fuer ganze x')|
      (* Fehlernummern fuer Formelausertung                              *)
      101:Assign(s,'Division durch Null')|
      102:Assign(s,'Overflow durch Division')|
      103:Assign(s,'Overflow durch Multiplikation')|
      104:Assign(s,'Overflow durch Addition')|
      105:Assign(s,'105:Overflow durch Subtraktion')|
      1001:Assign(s,'Wert liegt auusserhalb des Bildschirmes ')|
      1002:Assign(s,'Wert liegt nicht in Definitionsgebiet')|
      1003:Assign(s,'Grenzen oder Laufvariable ungueltig')|
    ELSE Assign(s,'Undefinierter Fehler');
    END;
  END GetFehlertext;
END FormelausFText.mod
