IMPLEMENTATION MODULE MyInfo;
(*
  Created:   3.3.1988 by
             Stefan Salewski
             Stolper Weg 3
             2160 Stade   West-Germany
             Tel: 04141/61130
             
  Note: compiled with AMIGA Modula-2 System by AMSoft from 5.5.88
   
  This Module may be freely copied. But please
  leave my name in. Thanks....Stefan  
*)
  FROM SYSTEM IMPORT ADR,ADDRESS,LONGSET;
  FROM Intuition IMPORT boolGadget,reqGadget,ActivationFlags,ActivationFlagSet,
    Border,GadgetFlagSet,IDCMPFlagSet,IntuiText,Requester,RequesterFlagSet,
    WindowPtr,InitRequester,Request,Gadget;
  FROM Graphics IMPORT jam2,jam1;
  FROM Preference IMPORT CharSize;

  CONST
    InfoReqHeight=110;
    InfoGadHeight=10;

  VAR
    infoGadgetWidth,infoReqWidth:INTEGER;
    charW,charH:INTEGER;
    InfoRequest:Requester;
    InfoGadText:IntuiText;
    InfoGad:Gadget;
    InfoGadBorder:Border;
    InfoGadPairs:ARRAY[1..10] OF INTEGER;

  PROCEDURE ShowInfo(wp: WindowPtr);
  BEGIN
    IF Request(ADR(InfoRequest),wp) THEN END
  END ShowInfo;

  PROCEDURE SetUpGadget;
  BEGIN
    InfoGadPairs[1]:=0;
    InfoGadPairs[2]:=0;    
    InfoGadPairs[3]:=infoGadgetWidth+1;
    InfoGadPairs[4]:=0;
    InfoGadPairs[5]:=infoGadgetWidth+1;
    InfoGadPairs[6]:=InfoGadHeight+1;
    InfoGadPairs[7]:=0;
    InfoGadPairs[8]:=InfoGadHeight+1;
    InfoGadPairs[9]:=0;
    InfoGadPairs[10]:=0;    
    WITH InfoGadBorder DO
      leftEdge:=-1;
      topEdge:=-1;
      frontPen:=3;
      backPen:=0;
      drawMode:=jam1;
      count:=5;
      xy:=ADR(InfoGadPairs);
      nextBorder:=NIL;
    END;
    WITH InfoGadText DO
     leftEdge:=3;
     topEdge:=1;
     frontPen:=2;
     backPen:=1;
     drawMode:=jam2;
     iText:=ADR("Continue");
     iTextFont:=NIL;
     nextText:=NIL;
    END;
    WITH InfoGad DO
      leftEdge:=(infoReqWidth DIV 2)-(infoGadgetWidth DIV 2);
      topEdge:=InfoReqHeight-InfoGadHeight-5;
      width:=infoGadgetWidth;
      height:=InfoGadHeight;
      flags:=GadgetFlagSet{};
      activation:=ActivationFlagSet{endGadget,relVerify};
      gadgetType:=boolGadget+reqGadget;
      gadgetRender:=ADR(InfoGadBorder);
      gadgetText:=ADR(InfoGadText);
      mutualExclude:=LONGSET{};
      nextGadget:=NIL;
      selectRender:=NIL; 
      specialInfo:=NIL;
      userData:=NIL;
      gadgetID:=0
    END;
  END SetUpGadget;
  VAR
    InfoReqBorder:Border;
    InfoReqPairs:ARRAY[1..10] OF INTEGER;
    InfoReqText:ARRAY[0..7] OF IntuiText;
  
  PROCEDURE SetUpRequester;
  BEGIN
    InfoReqPairs[1]:=0;
    InfoReqPairs[2]:=0;
    InfoReqPairs[3]:=infoReqWidth-3;
    InfoReqPairs[4]:=0;
    InfoReqPairs[5]:=infoReqWidth-3;
    InfoReqPairs[6]:=InfoReqHeight-3;
    InfoReqPairs[7]:=0;
    InfoReqPairs[8]:=InfoReqHeight-3;
    InfoReqPairs[9]:=0;
    InfoReqPairs[10]:=0;    
    WITH InfoReqBorder DO
      leftEdge:=1;
      topEdge:=1;
      frontPen:=3;
      backPen:=0;
      drawMode:=jam1;
      count:=5;
      xy:=ADR(InfoReqPairs);
      nextBorder:=NIL;
    END;
    InitRequester(ADR(InfoRequest));
    WITH InfoRequest DO
      leftEdge:=2;
      topEdge:=12;
      width:=infoReqWidth;
      height:=InfoReqHeight;
      reqGadget:=ADR(InfoGad);
      reqText:=ADR(InfoReqText);
      reqBorder:=ADR(InfoReqBorder);
      backFill:=1;
    END;
  END SetUpRequester;

  PROCEDURE SetUpRequesterText;

    PROCEDURE InitIText(VAR itext:IntuiText;L,T:CARDINAL;Next,text:ADDRESS);
    BEGIN
      WITH itext DO
        leftEdge:=L;
        topEdge:=T;
        frontPen:=2;
        backPen:=1;
        drawMode:=jam2;
        iText:=text;
        iTextFont:=NIL;
        nextText:=Next
      END
    END InitIText;

  BEGIN
    InitIText(InfoReqText[0],5,5,ADR(InfoReqText[1]), 
              ADR(" Autor: S. Salewski"));
    InitIText(InfoReqText[1],5,15, ADR(InfoReqText[2]), 
              ADR("   Stolper Weg 3"));
    InitIText(InfoReqText[2],5,25, ADR(InfoReqText[3]), 
              ADR("     2160 Stade"));
    InitIText(InfoReqText[3],5,35, ADR(InfoReqText[4]), 
              ADR("   West Germany"));
    InitIText(InfoReqText[4],5,45, ADR(InfoReqText[5]), 
              ADR("ALL RIGHTS RESERVED"));          
    InitIText(InfoReqText[5],5,60, ADR(InfoReqText[6]), 
              ADR("  Entwickelt mit:"));
    InitIText(InfoReqText[6],5,70,ADR(InfoReqText[7]),
              ADR("AMIGA MODULA2 System"));
    InitIText(InfoReqText[7],5,80, NIL,
              ADR(" by AMSoft V 3.11d"));
  END SetUpRequesterText;

BEGIN
  CharSize(charW,charH);
  infoGadgetWidth:=charW*8+6;
  infoReqWidth:=charW*20+10;
  SetUpGadget;
  SetUpRequesterText;
  SetUpRequester;
END MyInfo.mod
