IMPLEMENTATION MODULE MyRemember;
(*
  Created:   1987 by
             Stefan Salewski
             Stolper Weg 3
             2160 Stade   West-Germany
             Tel: 04141/61130
             
  Note: compiled with AMIGA Modula-2 System by AMSoft from 5.5.88
   
  This Module may be freely copied. But please
  leave my name in. Thanks....Stefan  
*)
  FROM Storage IMPORT ALLOCATE,DEALLOCATE;
  FROM SYSTEM IMPORT ADDRESS;

  PROCEDURE AllocRemember(VAR remKey:RememberNodePtr;VAR adr:ADDRESS;
                          size:LONGINT);
    VAR 
      nodePtr:RememberNodePtr;
    
  BEGIN
    ALLOCATE(adr,size);
    ALLOCATE(nodePtr,SIZE(nodePtr^));
    nodePtr^.previous:=remKey;
    nodePtr^.memSize:=size;
    nodePtr^.adr:=adr;
    remKey:=nodePtr;
  END AllocRemember;
  
  PROCEDURE FreeRemember(VAR remKey:RememberNodePtr);
    VAR
      ptr:RememberNodePtr;
  BEGIN
    WHILE remKey # NIL DO
      ptr:=remKey;
      remKey:=remKey^.previous;
      DEALLOCATE(ptr^.adr,ptr^.memSize);
      DEALLOCATE(ptr,SIZE(ptr^));
    END;
  END FreeRemember; 
      
END MyRemember.mod
