(*---------------------------------------------------------------------------
    :Program.    MakeInline.mod
    :Author.     Bernd Preusing
    :Address.    Gerhardstr. 16  D-2200 Elmshorn
    :Phone.      04121/22486
    :Shortcut.   [bep]
    :Version.    1.1
    :Date.       Aug-87
    :Copyright.  PD
    :Language.   Modula-II
    :Translator. M2Amiga
    :Imports.    TwoFiles, InOut2
    :UpDate.     1.1 Oct-88 use TwoFiles
    :Contents.   converts binary file to INLINE text
    :Remark.     
---------------------------------------------------------------------------*)
MODULE MakeInline;

FROM InOut2 IMPORT
  done, CloseInput, CloseOutput,
  ReadBytes, Write, WriteLn, WriteString, WriteHex;

FROM TwoFiles IMPORT
  OpenFiles;


VAR
 Buffer: CARDINAL;
 Adr: LONGINT;
 Komma:BOOLEAN;

PROCEDURE PutCode;
BEGIN
 Komma:=FALSE;
 LOOP
   ReadBytes(Buffer);
   IF done THEN
     IF Komma THEN Write(',') END;
     IF (Adr MOD 16)=0 THEN
       WriteLn;
       WriteString('(*'); WriteHex(Adr,4); WriteString('*) ');
     END;
     WriteHex(Buffer,5); Write('H'); Komma:=TRUE;
     INC(Adr,2);
   ELSE
     EXIT
   END
 END
END PutCode;

BEGIN
 WriteLn;
 WriteString('Konverter fr M2Amiga-INLINE-Prozeduren');
 WriteLn;
 WHILE OpenFiles(TRUE,TRUE) DO
   WriteString('INLINE(');
   Adr:=0;
   PutCode;
   WriteString(');'); WriteLn;
   CloseInput;
   CloseOutput;
   WriteString(' $'); WriteHex(Adr,4); WriteString(' Bytes geschr.');
   WriteLn;
   WriteLn;
 END;
 WriteString('--- fertig ---'); WriteLn
END MakeInline.mod
