(*---------------------------------------------------------------------------
    :Program.    FileReqDemo.mod
    :Author.     Fridtjof Siebert
    :Address.    Nobileweg 67, D-7-Stgt-40
    :Shortcut.   [fbs]
    :Version.    1.0
    :Date.       30-Dec-88
    :Copyright.  PD
    :Language.   Modula-II
    :Translator. M2Amiga v3.1d
    :Imports.    arp.library
    :Contents.   example for use of arp.FileRequest()
---------------------------------------------------------------------------*)

MODULE FileReqDemo;

FROM SYSTEM   IMPORT ADR;
FROM ARP      IMPORT FileRequest, FileRequester, FileName, DirName,
                     FileReqFlagSet;
FROM Terminal IMPORT WriteString, WriteLn;

VAR
  FR: FileRequester;
  File: FileName;
  Dir: DirName;

BEGIN
  File := "Inhalt";
  Dir  := "DF0:";
  WITH FR DO
    hail      := ADR("File-Requester Demo");
    ddef      := ADR(File);
    ddir      := ADR(Dir);
    wind      := NIL;
    funcFlags := FileReqFlagSet{};
    reserved1 := 0;
    function  := NIL;
    reserved2 := 0;
  END;
  IF FileRequest(ADR(FR))#NIL THEN
    WriteString(File); WriteLn;
    WriteString(Dir ); WriteLn;
  ELSE
    WriteString("Cancelled"); WriteLn;
  END;
END FileReqDemo.
