(*---------------------------------------------------------------------------
   :Program.    Kurve
   :Author.     Jrg Wesemann
   :Address.    Auf der Heide 10, 2807 Achim - Baden
   :Phone.      (0)4202 / 70658
   :Shortcut.   [jwe]
   :Version.    2.94
   :Date.       23.03.89
   :Copyright.  PD
   :Language.   Modula-II
   :Translator. M2Amiga
   :Imports.    none.
   :Update.     none.
   :Contents.   none.
   :Remark.     none
---------------------------------------------------------------------------*)



IMPLEMENTATION MODULE imagedata;

FROM Arts 		IMPORT 	Assert;
FROM SYSTEM 		IMPORT 	INLINE,ADR;
FROM Exec 		IMPORT 	AllocMem,MemReqs,MemReqSet;


  PROCEDURE CopyToChip(von: CARDPTR; VAR nach: CARDPTR; n: LONGINT);
    VAR
      chipramptr	: CARDPTR;
      fertig    	: LONGINT;
  
  BEGIN
    chipramptr:= AllocMem(n,MemReqSet{chip});
    Assert(chipramptr # NIL,ADR("Kein ChipRam fr IMAGE"));
    nach:= chipramptr;
    fertig:= 0;
    REPEAT
      chipramptr^:= von^;
      INC(chipramptr,2); INC(von,2); INC(fertig,2);
    UNTIL (fertig>=n);
  END CopyToChip;


  (* $E- *)
  PROCEDURE okimagedata;
  
  BEGIN
    INLINE(0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFF0H,0FFFFH,
	   0FFFFH,0FFFFH,0FFFFH,0FFF0H,0FFFFH,0FFFFH,
   	   0FFFFH,0FFFFH,0FFF0H,0FFFFH,0FFFFH,0FFFFH,
	   0FFFFH,0FFF0H,0FFFFH,0E0FFH,0F863H,0FFFFH,
	   0FFF0H,0FFFFH,0C47FH,0FC63H,0FFFFH,0FFF0H,
	   0FFFFH,8E3FH,0FC47H,0FFFFH,0FFF0H,0FFFFH,
	   8E3FH,0FC0FH,0FFFFH,0FFF0H,0FFFFH,8E3FH,
	   0FC47H,0FFFFH,0FFF0H,0FFFFH,0C47CH,7C63H,
	   0C7FFH,0FFF0H,0FFFFH,0E0FCH,7863H,0C7FFH,
	   0FFF0H,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFF0H,
	   0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFF0H,0FFFFH,
	   0FFFFH,0FFFFH,0FFFFH,0FFF0H,0FFFFH,0FFFFH,
           0FFFFH,0FFFFH,0FFF0H,0FFFFH,0FFFFH,0FFFFH,
	   0FFFFH,0FFF0H,0FFFFH,0FFFFH,0FFFFH,0FFFFH,
	   0FFF0H,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFF0H,
	   0000H,0000H,0000H,0000H,0000H,0000H,
	   0000H,0000H,0000H,0000H,

	   0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFF0H,0FFFFH,
	   0FFFFH,0FFFFH,0FFFFH,0FFF0H,0FFFFH,0FFFFH,
	   0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,
	   0FFFFH,0FFFFH,0FFFFH,0E0FFH,0F863H,0FFFFH,
	   0FFFFH,0FFFFH,0C47FH,0FC63H,0FFFFH,0FFFFH,
	   0FFFFH,8E3FH,0FC47H,0FFFFH,0FFFFH,0FFFFH,
	   8E3FH,0FC0FH,0FFFFH,0FFFFH,0FFFFH,8E3FH,
	   0FC47H,0FFFFH,0FFFFH,0FFFFH,0C47CH,7C63H,
	   0C7FFH,0FFFFH,0FFFFH,0E0FCH,7863H,0C7FFH,
	   0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,
	   0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,
	   0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,
	   0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,
	   0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,
	   0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,
	   03FFFH,0FFFFH,0FFFFH,0FFFFH,0FFFFH,03FFFH,
	   0FFFFH,0FFFFH,0FFFFH,0FFFFH
          );
  END okimagedata;


  (* $E- *)
  PROCEDURE okhimagedata;
  BEGIN
    INLINE(0000H,0000H,0000H,0000H,0000H,07FFFH,
	   0FFFFH,0FFFFH,0FFFFH,0FFFEH,7FFFH,0FFFFH,
	   0FFFFH,0FFFFH,0FFFEH,7FFFH,0FFFFH,0FFFFH,
	   0FFFFH,0FFFEH,7FFFH,0FFFFH,0FFFFH,0FFFFH,
	   0FFFEH,7FFFH,0FF83H,0FFE1H,8FFFH,0FFFEH,
	   7FFFH,0FF11H,0FFF1H,8FFFH,0FFFEH,7FFFH,
	   0FE38H,0FFF1H,1FFFH,0FFFEH,7FFFH,0FE38H,
	   0FFF0H,03FFFH,0FFFEH,7FFFH,0FE38H,0FFF1H,
	   1FFFH,0FFFEH,7FFFH,0FF11H,0F1F1H,8F1FH,
	   0FFFEH,7FFFH,0FF83H,0F1E1H,8F1FH,0FFFEH,
	   7FFFH,0FFFFH,0FFFFH,0FFFFH,0FFFEH,7FFFH,
	   0FFFFH,0FFFFH,0FFFFH,0FFFEH,7FFFH,0FFFFH,
	   0FFFFH,0FFFFH,0FFFEH,7FFFH,0FFFFH,0FFFFH,
	   0FFFFH,0FFFEH,7FFFH,0FFFFH,0FFFFH,0FFFFH,
	   0FFFEH,7FFFH,0FFFFH,0FFFFH,0FFFFH,0FFFEH,
	   7FFFH,0FFFFH,0FFFFH,0FFFFH,0FFFEH,0000H,
	   0000H,0000H,0000H,0000H,

	   0000H,0000H,0000H,0000H,0000H,07FFFH,
	   0FFFFH,0FFFFH,0FFFFH,0FFFEH,7FFFH,0FFFFH,
	   0FFFFH,0FFFFH,0FFFEH,7FFFH,0FFFFH,0FFFFH,
	   0FFFFH,0FFFEH,7FFFH,0FFFFH,0FFFFH,0FFFFH,
	   0FFFEH,7FFFH,0FF83H,0FFE1H,8FFFH,0FFFEH,
	   7FFFH,0FF11H,0FFF1H,8FFFH,0FFFEH,7FFFH,
	   0FE38H,0FFF1H,1FFFH,0FFFEH,7FFFH,0FE38H,
	   0FFF0H,3FFFH,0FFFEH,7FFFH,0FE38H,0FFF1H,
	   1FFFH,0FFFEH,7FFFH,0FF11H,0F1F1H,8F1FH,
	   0FFFEH,7FFFH,0FF83H,0F1E1H,8F1FH,0FFFEH,
	   7FFFH,0FFFFH,0FFFFH,0FFFFH,0FFFEH,7FFFH,
	   0FFFFH,0FFFFH,0FFFFH,0FFFEH,7FFFH,0FFFFH,
	   0FFFFH,0FFFFH,0FFFEH,7FFFH,0FFFFH,0FFFFH,
	   0FFFFH,0FFFEH,7FFFH,0FFFFH,0FFFFH,0FFFFH,
	   0FFFEH,7FFFH,0FFFFH,0FFFFH,0FFFFH,0FFFEH,
	   7FFFH,0FFFFH,0FFFFH,0FFFFH,0FFFEH,0000H,
	   0000H,0000H,0000H,0000H
          );
  END okhimagedata;


  (* $E- *)
  PROCEDURE wahlimagedata;
  BEGIN
    INLINE(0FFFFFFFFH,0FFFFFFFFH,0FFFFFFFFH,0FFFFE000H,0FFFFFFFFH,0FFFFFFFFH,
           0FFFFFFFFH,0FFFFE000H,0FFFFFFFFH,0FFFFF001H,0FFFFFFFFH,0FFFFE000H,
           0FFFFFFFFH,000000000H,000001FFFH,0FFFFE000H,0FFFFFFFCH,000000FFEH,
           0000007FFH,0FFFFE000H,0FFFFFFF0H,000007FFFH,0FFFFC1FFH,0FFFFE000H,
           0FFFFFFE1H,0FFFFFFFFH,0FFFFF0FFH,0FFFFE000H,0FFFFFFC7H,0FFFFFFFFH,
           0FFFFFC7FH,0FFFFE000H,0FFFFFFC7H,0FFFFFFFFH,0FFFFFC7FH,0FFFFE000H,
           0FFFFFF8FH,0FFFFFFFFH,0FFFFFE3FH,0FFFFE000H,0FFFFFF8FH,0FFFFFFFFH,
           0FFFFFE3FH,0FFFFE000H,0FFFFFF8FH,0FFFFFFFFH,0FFFFFE3FH,0FFFFE000H,
           0FFFFFFC7H,0FFFFFFFFH,0FFFFFC7FH,0FFFFE000H,0FFFFFFC7H,0FFFFFFFFH,
           0FFFFFC7FH,0FFFFE000H,0FFFFFFE1H,0FFFFFFFFH,0FFFFF0FFH,0FFFFE000H,
           0FFFFFFF0H,000007FFFH,0FFFFC1FFH,0FFFFE000H,0FFFFFFFCH,000000FFEH,
           0000007FFH,0FFFFE000H,0FFFFFFFFH,000000000H,000001FFFH,0FFFFE000H,
           0FFFFFFFFH,0FFFFF001H,0FFFFFFFFH,0FFFFE000H,0FFFFFFFFH,0FFFFFFFFH,
           0FFFFFFFFH,0FFFFE000H,0FFFFFFFFH,0FFFFFFFFH,0FFFFFFFFH,0FFFFE000H,
           0FFFFFFFFH,0FFFFFFFFH,0FFFFFFFFH,0FFFFE000H,0FFFFFFFFH,0FFFFFFFFH,
           0FFFFFFFFH,0FFFFE000H,0FFFFFFFFH,0FFFFF001H,0FFFFFFFFH,0FFFFE000H,
           0FFFFFFFFH,000000FFEH,000001FFFH,0FFFFE000H,0FFFFFFFCH,0FFFFFFFFH,
           0FFFFE7FFH,0FFFFE000H,0FFFFFFF3H,0FFFFFFFFH,0FFFFF9FFH,0FFFFE000H,
           0FFFFFFE7H,0FFFFFFFFH,0FFFFFCFFH,0FFFFE000H,0FFFFFFDFH,0FFFFFFFFH,
           0FFFFFF7FH,0FFFFE000H,0FFFFFFDFH,0FFFFFFFFH,0FFFFFF7FH,0FFFFE000H,
           0FFFFFFBFH,0FFFFFFFFH,0FFFFFFBFH,0FFFFE000H,0FFFFFFBFH,0FFFFFFFFH,
           0FFFFFFBFH,0FFFFE000H,0FFFFFFBFH,0FFFFFFFFH,0FFFFFFBFH,0FFFFE000H,
           0FFFFFFDFH,0FFFFFFFFH,0FFFFFF7FH,0FFFFE000H,0FFFFFFDFH,0FFFFFFFFH,
           0FFFFFF7FH,0FFFFE000H,0FFFFFFE7H,0FFFFFFFFH,0FFFFFCFFH,0FFFFE000H,
           0FFFFFFF3H,0FFFFFFFFH,0FFFFF9FFH,0FFFFE000H,0FFFFFFFCH,0FFFFFFFFH,
           0FFFFE7FFH,0FFFFE000H,0FFFFFFFFH,000000FFEH,000001FFFH,0FFFFE000H,
           0FFFFFFFFH,0FFFFF001H,0FFFFFFFFH,0FFFFE000H,0FFFFFFFFH,0FFFFFFFFH,
           0FFFFFFFFH,0FFFFE000H,0FFFFFFFFH,0FFFFFFFFH,0FFFFFFFFH,0FFFFE000H
         );
  
  END wahlimagedata;


  (* $E- *)
  PROCEDURE wahlhimagedata;
  BEGIN
    INLINE(000001FFFH,0FFFFFFBFH,0FFFFFFFFH,000000000H,0FFFFC7FFH,0FFFFFFFFH,
           0FFFFFFFCH,000006000H,0FFFFF1FFH,0FFFFF001H,0FFFFFFF1H,0FFFFE000H,
           0FFFFFFFFH,000000000H,000001FFFH,0FFFFE000H,0FFFFFFFCH,000000FBEH,
           0000007FFH,0FFFFE000H,0FFFFFFF0H,000007FBFH,0FFFFC1FFH,0FFFFE000H,
           0FFFFFFE1H,0FFFFFFBFH,0FFFFF0FFH,0FFFFE000H,0FFFFFFC7H,0FFFFFFBFH,
           0FFFFFC7FH,0FFFFE000H,0FFFFFFC7H,0FFFFF1B1H,0FFFFFC7FH,0FFFFE000H,
           0FFFFFF8FH,0FFFFFE0FH,0FFFFFE3FH,0FFFFE000H,000000780H,000000000H,
           00000003CH,000000000H,0FFFFFF8FH,0FFFFFE0FH,0FFFFFE3FH,0FFFFE000H,
           0FFFFFFC7H,0FFFFF1B1H,0FFFFFC7FH,0FFFFE000H,0FFFFFFC7H,0FFFFFFBFH,
           0FFFFFC7FH,0FFFFE000H,0FFFFFFE1H,0FFFFFFBFH,0FFFFF0FFH,0FFFFE000H,
           0FFFFFFF0H,000007FBFH,0FFFFC1FFH,0FFFFE000H,0FFFFFFFCH,000000FBEH,
           0000007FFH,0FFFFE000H,0FFFFFFFFH,000000000H,000001FFFH,0FFFFE000H,
           0FFFFF1FFH,0FFFFF001H,0FFFFFFF1H,0FFFFE000H,0FFFFC7FFH,0FFFFFFFFH,
           0FFFFFFFCH,000006000H,000001FFFH,0FFFFFFBFH,0FFFFFFFFH,000000000H,
           0FFFFFFFFH,0FFFFFFFFH,0FFFFFFFFH,0FFFFE000H,0FFFFFFFFH,0FFFFFFFFH,
           0FFFFFFFFH,0FFFFE000H,0FFFFFFFFH,0FFFFF001H,0FFFFFFFFH,0FFFFE000H,
           0FFFFFFFFH,000000FFEH,000001FFFH,0FFFFE000H,0FFFFFFFCH,0FFFFFFFFH,
           0FFFFE7FFH,0FFFFE000H,0FFFFFFF3H,0FFFFFFFFH,0FFFFF9FFH,0FFFFE000H,
           0FFFFFFE7H,0FFFFFFFFH,0FFFFFCFFH,0FFFFE000H,0FFFFFFDFH,0FFFFFFBFH,
           0FFFFFF7FH,0FFFFE000H,0FFFFFFDFH,0FFFFF1B1H,0FFFFFF7FH,0FFFFE000H,
           0FFFFFFBFH,0FFFFFE0FH,0FFFFFFBFH,0FFFFE000H,0FFFFFFBFH,0FFFFF001H,
           0FFFFFFBFH,0FFFFE000H,0FFFFFFBFH,0FFFFFE0FH,0FFFFFFBFH,0FFFFE000H,
           0FFFFFFDFH,0FFFFF1B1H,0FFFFFF7FH,0FFFFE000H,0FFFFFFDFH,0FFFFFFBFH,
           0FFFFFF7FH,0FFFFE000H,0FFFFFFE7H,0FFFFFFFFH,0FFFFFCFFH,0FFFFE000H,
           0FFFFFFF3H,0FFFFFFFFH,0FFFFF9FFH,0FFFFE000H,0FFFFFFFCH,0FFFFFFFFH,
           0FFFFE7FFH,0FFFFE000H,0FFFFFFFFH,000000FFEH,000001FFFH,0FFFFE000H,
           0FFFFFFFFH,0FFFFF001H,0FFFFFFFFH,0FFFFE000H,0FFFFFFFFH,0FFFFFFFFH,
           0FFFFFFFFH,0FFFFE000H,0FFFFFFFFH,0FFFFFFFFH,0FFFFFFFFH,0FFFFE000H
         );
  END wahlhimagedata;


END imagedata.
