MODULE AverageAge2;   (* Calculate average age with type declaration *)

  (* From the book "Modula-2  A Seafarer's Manual and Shipyard Guide" *)
  (* Page 91   adapted "Amiga M2Modula-2"   06 Mar 1988 *)

FROM InOut IMPORT WriteLn,
                  WriteString,
                  ReadCard;
FROM RealInOut IMPORT WriteReal;

CONST
  CrewSize = 25;
  
TYPE
  CrewRange = [1..CrewSize];
  
VAR
  i : CrewRange;
  average : REAL;
  CrewAge : ARRAY CrewRange OF CARDINAL;
  
BEGIN
  WriteLn;
  WriteString ("Enter crew ages: ");
  WriteLn;
  
  FOR i := 1 TO CrewSize BY 1 DO
    ReadCard (CrewAge[i]);  		 (* get age from keyboard *)
    WriteLn;
  END;
  
  average := 0.0;
  FOR i:= 1 TO CrewSize BY 1 DO  	 (* sum ages *)
    average := average + FLOAT (CrewAge[i]);
  END;
  
  average := average / FLOAT (CrewSize); (* calculate average *)
  WriteLn;
  WriteString ("Average age = ");
  WriteReal (average,10,2);
  WriteLn;
  
END AverageAge2.

