MODULE C5P1;  (* Chapter 5  Problem 1 *)
              (* Calculate the Fibonacci number *)

  (* From the book "Modula-2  A Seafarer's Manual and Shipyard Guide" *)
  (* Page 161   adapted "Amiga M2Modula-2"   11 Mar 1988 *)

FROM InOut IMPORT WriteLn,
                  WriteCard,
                  WriteString,
                  ReadLongCard;
           
VAR
  base : LONGCARD;		(* base from keyboard *)

PROCEDURE Fib (x : LONGCARD) : LONGCARD;
  
  BEGIN
    IF (x <= 2) THEN
      RETURN 1;
    ELSE
      RETURN ( Fib(x-1) + Fib(x-2) );
    END;   (* IF *)
    
  END Fib;
  
  
BEGIN
  WriteLn;
  WriteString ("Calculate the Fibonacci number.");
  WriteLn; WriteLn; WriteLn;
  WriteString ("Input number: ");
  ReadLongCard (base);
  WriteLn;
  WriteString ("The Fibonacci number of ");
  WriteCard (base,4);
  WriteString (" is ");
  WriteCard ( Fib(base), 10 );
  WriteLn;
  
END C5P1.
