(*---------------------------------------------------------------------------
  :Program.    Preference.mod
  :Author.     Stefan Salewski
  :Address.    Stolper Weg 3, D-2160 Stade
  :Shortcut.   [sts]
  :Version.    1.0
  :Date.       2-apr-89
  :Copyright.  Public Domain
  :Language.   Modula-2
  :Translator. M2Amiga AMSoft V3.2d
  :History.    Created 1987 for R.o.M.(Amok Disk 11) by [sts]
  :Contents.   Procedur CharSize to determine the WB-Charactersize
---------------------------------------------------------------------------*)

IMPLEMENTATION MODULE Preference;
(*
  Created:   1987
  Changed:   16.3.89 by
             Stefan Salewski
             Stolper Weg 3
             2160 Stade   West-Germany
             Tel: 04141/61130
             
  Note: compiled with AMIGA Modula-2 System by AMSoft Version 3.2d
   
  This Module may be freely copied.
*)

  FROM Intuition IMPORT PreferencesPtr,GetPrefs,topazEighty;
  FROM Storage IMPORT ALLOCATE,DEALLOCATE;
  FROM SYSTEM IMPORT ADR;
  FROM Arts IMPORT Assert;

  PROCEDURE CharSize(VAR width,height:INTEGER);
    VAR
    prefPtr:PreferencesPtr;
  BEGIN
    ALLOCATE(prefPtr,SIZE(prefPtr^));
    Assert(prefPtr#NIL,ADR('Preference: Out Of Mem!'));
    GetPrefs(prefPtr,SIZE(prefPtr^));
    IF prefPtr^.fontHeight=topazEighty THEN
      width:=8;
      height:=8
    ELSE
      width:=10;
      height:=9;(*I hope this is correct *)
    END;
    DEALLOCATE(prefPtr,SIZE(prefPtr));
  END CharSize;
END Preference.mod

