(*---------------------------------------------------------------------------
  :Program.    QText.mod
  :Author.     Fridtjof Siebert
  :Address.    Nobileweg 67, D-7-Stgt-40
  :Phone.      (0)711/822509
  :Shortcut.   [fbs]
  :Version.    1.0
  :Date.       29-Apr-89
  :Copyright.  PD
  :Language.   Assembler
  :Translator. M2Amiga v3.1d / Profimat
  :Contents.   Procedure for fast text-output on a BitMap
---------------------------------------------------------------------------*)

IMPLEMENTATION MODULE QText;

FROM SYSTEM   IMPORT ADDRESS, INLINE;
FROM Graphics IMPORT BitMapPtr, TextFontPtr;

PROCEDURE QText(x{0},y{1}: INTEGER;
                str{8}: ADDRESS;
                bm{9}: BitMapPtr;
                tf{10}: TextFontPtr);  (* $E- *)

(* Gibt str^ an Position x,y in bm mit dem Font tf aus *)
(* x gibt position in Zeichenbreiten (8 Pixel) an.     *)

BEGIN
INLINE(
(*0000*) 048E7H,0F0F0H,03429H,00000H,048C2H,0C2C2H,048C0H,0D280H,
(*0010*) 02269H,00008H,0D3C1H,02202H,0E781H,09282H,05381H,0246AH,
(*0020*) 00022H,01018H,06700H,00082H,01600H,0C63CH,00060H,06600H,
(*0030*) 00034H,012BCH,000FEH,0D3C2H,012BCH,000C6H,0D3C2H,012BCH,
(*0040*) 000C6H,0D3C2H,012BCH,000C6H,0D3C2H,012BCH,000C6H,0D3C2H,
(*0050*) 012BCH,000C6H,0D3C2H,012BCH,000FEH,0D3C2H,012BCH,00000H,
(*0060*) 093C1H,060BEH,0903CH,00020H,06A04H,0903CH,00020H,0C07CH,
(*0070*) 000FFH,047F2H,00000H,01293H,0D3C2H,012ABH,000C0H,0D3C2H,
(*0080*) 012ABH,00180H,0D3C2H,012ABH,00240H,0D3C2H,012ABH,00300H,
(*0090*) 0D3C2H,012ABH,003C0H,0D3C2H,012ABH,00480H,0D3C2H,012ABH,
(*00A0*) 00540H,093C1H,06000H,0FF7CH,04CDFH,00F0FH,04E75H);
END QText;

END QText.

