(*---------------------------------------------------------------------------
   :Program.    Kurve
   :Author.     Jrg Wesemann
   :Address.    Auf der Heide 10, 2807 Achim - Baden
   :Phone.      (0)4202 / 70658
   :Shortcut.   [jwe]
   :Version.    2.94
   :Date.       23.03.89
   :Copyright.  PD
   :Language.   Modula-II
   :Translator. M2Amiga
   :Imports.    none.
   :Update.     none.
   :Contents.   Stellt Screen und Window bereit
   :Remark.     none
---------------------------------------------------------------------------*)



IMPLEMENTATION MODULE kurvescreen;

FROM SYSTEM 		IMPORT 	ADR;
FROM Intuition 		IMPORT 	ScreenPtr,customScreen,NewScreen,OpenScreen,
				NewWindow,WindowPtr,IDCMPFlags,IDCMPFlagSet,
                                WindowFlags,WindowFlagSet,OpenWindow,IntuiText,
                                Gadget,boolGadget,GadgetFlags,GadgetFlagSet,
                                ActivationFlags,ActivationFlagSet,Border;
FROM Graphics 		IMPORT 	ViewModes,ViewModeSet,jam1;
FROM startupproc 	IMPORT 	string,STRING;


PROCEDURE MakeWindow(scr : ScreenPtr; VAR gadid: INTEGER):WindowPtr;

  VAR
    win		: NewWindow;

BEGIN

  WITH win DO
    leftEdge:= 0; topEdge:= 0; width:= 640; height:= 512;
    detailPen:= 0; blockPen:= 1;
    idcmpFlags:= IDCMPFlagSet{closeWindow,mouseMove,mouseButtons};
    flags:= WindowFlagSet{reportMouse,borderless,windowClose};
    firstGadget:= NIL;
    checkMark:= NIL;
    title:= ADR(string); screen:= scr; bitMap:= NIL; 
    minWidth:= 640; minHeight:= 512; maxWidth:= 640; maxHeight:= 512;
    type:= customScreen;
  END;
  RETURN OpenWindow(win);

END MakeWindow;



PROCEDURE InitScreen(VAR s:NewScreen);

BEGIN
    WITH s DO
      leftEdge:=0; topEdge:=0; 
      width:=640; height:=512;
      depth:=1;
      detailPen:=0; blockPen:=1;  (* Hintergrund, Vordergrund *)
      viewModes:=ViewModeSet{hires,lace};
      type:=customScreen;
      font:=NIL;
      defaultTitle:=ADR(string);
      gadgets:=NIL;
      customBitMap:=NIL
    END;

END InitScreen;



PROCEDURE SetUpScreen():ScreenPtr;
  
  VAR
    ns : 	NewScreen;

BEGIN
  InitScreen(ns);
  RETURN OpenScreen(ns);

END SetUpScreen;

  
      
END kurvescreen.
