(*==============================================================*)
(* Ein Versuch, Arts.mod aus dem DisObject-Listing mglichst	*)
(* exakt zu rekonstruieren.					*)
(* Dies soll nur eine Studie sein und niemanden einladen, an	*)
(* Arts 'herumzubasteln'! Sonst ist Kompatibilitt demnchst	*)
(* eine prhistorische Vokabel.					*)
(* Bernd Preusing, Gerhardstr. 16, 2200 Elmshorn		*)
(*--------------------------------------------------------------*)
(* Die Routine Divu32 enthlt zwei schwere Fehler, die zu	*)
(* falschen Ergebnissen fhren. Umso schlimmer, da Divs32	*)
(* nach Vorzeichenkorrektur Divu32 aufruft!			*)
(* Auf der Diskette ist ein korrigiertes Arts.obj !!		*)
(* Die mathematischen Prozeduren bestehen aus INLINE-Code	*)
(* und sind hier nur angedeutet. Dies Modul ist zwar compilier- *)
(* bar, aber nicht lauffhig!!!!!				*)
(* An einigen Stellen erscheint SETREG(D0,...). Dies dient dazu,*)
(* eine Funktionsprozedur als Prozedur aufzurufen.		*)
(*--------------------------------------------------------------*)

IMPLEMENTATION MODULE Arts;


FROM SYSTEM IMPORT
	ADR, ADDRESS, CAST, LONGSET, INLINE, REG, SETREG; (* in die Vollen! *)

FROM ASSEMBLER IMPORT
	D0,D1,D2,D3,D4,D5,D6,D7,A0,A1,A2,A3,A4,A5,A6,A7,
	RTE, RTS, PUSHA4, POPA4;

FROM Dos IMPORT
	Process, CurrentDir;

FROM Exec IMPORT
	UByte, Task, TaskPtr, MemReqs, MemReqSet, MsgPortPtr, AttnFlags,
        ExecBase, execBase, Message,
	Forbid, Permit, RawDoFmt, SetExcept;


(* Workbench: wird nicht importiert, weil sonst auch Intuition dazukommt,
   und dann kommt von Intuition noch Timer, KeyMap, etc. *)
TYPE
	WBArg = RECORD
	  lock, name:ADDRESS
	END;
	WBArgumentsPtr = POINTER TO ARRAY[0..255] OF WBArg;
	WBStartupPtr = POINTER TO WBStartup;
	WBStartup = RECORD
	  message: Message;
	  process, segment: ADDRESS;
	  numArgs:LONGINT;
	  toolWindow: ADDRESS;
	  argList: WBArgumentsPtr
	END;
(*------------------------------------------------------------*)

TYPE
     AdrPtr = POINTER TO ADDRESS;
     ProcessPtr = POINTER TO Process; (* Heinis!! *)

     IntuiTextPtr=POINTER TO IntuiText; (* siehe Workbench *)
     IntuiText= RECORD
       frontPen, backPen: UByte;
       drawMode:UByte;
       leftEdge, topEdge: INTEGER;
       iTextFont, iText: ADDRESS;
       nextText: IntuiTextPtr
     END;

     ProcNodePtr = POINTER TO ProcNode;
     ProcNode = RECORD (* Verwaltung von Debug- und Term-Liste *)
       next: ProcNodePtr;
       proc: PROC;
       level: INTEGER;
       active: BOOLEAN
     END;

CONST
  jam2 = 1; (* DrawModeSet{dm0} *)

  (* Ich habe nicht alle Texte als Konstanten definiert, dadurch ist die
     Reihenfolge der Texte nicht genauso wie im Original.
   *)
  msAssert = 'Modula-2 Assert';
  msBreak = 'Modula-2 BreakPoint';

  msSystemError='SystemError (%d)';
  msLaufzeit = 'Modula-2 Laufzeitfehler';

VAR (* nach denen des Def-Modules *)
	AbsExec[4]:ADDRESS;

	SysMessages: ARRAY[halt..illCall] OF ADDRESS;
	TrapMessages: ARRAY[0..7] OF ADDRESS;
	RangeMessage,OverflowMessage: ADDRESS;
	rawDoProc: LONGCARD;
	myProcess: ProcessPtr;
	currLevel: INTEGER;
	termAllowed: BOOLEAN;
	SPArr: ARRAY[0..7] OF ADDRESS;
	IText1,IText2,IText3, IText4, IText5: IntuiText;
	oldTrapProc, oldExceptProc: PROC;
	termList, debugList: ProcNodePtr;
	cpu68000,cpu68010,cpu68020: BOOLEAN;
	WBstartup: WBStartupPtr;
	rawDoString: ARRAY[0..31] OF CHAR;

(* Diese Prozeduren sind notwendig, damit die Routinen auch funktionieren,
   wenn die Libraries noch nicht geffnet sind.
   Dies funktioniert aber nur innerhalb eines Moduls, niemals durch Importe,
   weil sonst A6 wieder berschrieben wird! Siehe z.B. Timer.def.
*)
PROCEDURE SPAllocMem(base{A6}:ADDRESS;byteSize{D0}:LONGINT;
		requirements{D1}:MemReqSet):ADDRESS;
CODE -198;

PROCEDURE SPFreeMem(base{A6}:ADDRESS; memoryBlock{A1}:ADDRESS;
		byteSize{D0}:LONGINT);
CODE -210;

PROCEDURE SPKillMsg(base{A6}:ADDRESS; port{A0}:MsgPortPtr);
CODE -372;
PROCEDURE SPGetMsg(base{A6}:ADDRESS; port{A0}:MsgPortPtr):ADDRESS;
CODE -372;

PROCEDURE SPOpenLibrary(base{A6}:ADDRESS; libName{A1}:ADDRESS;
		version{D0}:LONGINT): ADDRESS;
CODE -552;

PROCEDURE SPCloseLibrary(base{A6}:ADDRESS; library{A1}:ADDRESS);
CODE -414;

PROCEDURE SPForbid(base{A6}:ADDRESS);
CODE -132;

PROCEDURE SPReplyMsg(base{A6}:ADDRESS; message{A1}:ADDRESS);
CODE -378;

PROCEDURE SPFindTask(base{A6}:ADDRESS; name{A1}:ADDRESS):TaskPtr;
CODE -294;

PROCEDURE SPWaitPort(base{A6}:ADDRESS; port{A0}:MsgPortPtr);
CODE -384;

(* Intuition *)
PROCEDURE SPAutoRequest(base{A6}:ADDRESS; window{A0}:ADDRESS;
	Body{A1}, PText{A2}, NText{A3}: ADDRESS;
	PFlag{D0}, NFlag{D1}:LONGSET; W{D2}, H{D3}:INTEGER): LONGINT;
CODE -348;

(* $S- $V- *)

PROCEDURE InitMessages();
BEGIN
  SysMessages[halt]	:=ADR("Programmiertes HALT");
  SysMessages[illCase]  :=ADR("Ungltiger CASE Index");
  SysMessages[fctReturn]:=ADR("Funktion ohne RETURN beendet");
  SysMessages[stkOvl]   :=ADR("STAPEL BERLAUF");
  SysMessages[illCall]  :=ADR("Ungltiger Aufruf von Arts.Call");
  TrapMessages[3] :=ADR("Address Fehler");
  TrapMessages[4] :=ADR("Ungltige Instruktion");
  TrapMessages[5] :=ADR("Division durch Null");
  TrapMessages[6] :=ADR("Bereichsfehler (CHK)");
  TrapMessages[7] :=ADR("berlauf (TRAPV)");
  RangeMessage    :=ADR("Bereichsfehler(lang)");
  OverflowMessage :=ADR("berlauf (lang)");
END InitMessages;

PROCEDURE AddPROC(VAR l:ProcNodePtr; p:PROC);
VAR a: ProcNodePtr;
BEGIN
  a:=SPAllocMem(AbsExec,SIZE(ProcNode),MemReqSet{memClear});
  Assert(a#NIL,ADR("Speichermangel"));
  WITH a^ DO (* AddHead *)
    proc:=p;
    next:=l;
    level:=currLevel;
    active:=FALSE
  END;
  l:=a;
END AddPROC;

PROCEDURE DeletePROC(VAR l:ProcNodePtr; p:PROC);
VAR a,b: ProcNodePtr;
BEGIN
  a:=l;
  IF a^.proc=p THEN
    l:=a^.next; (* DeleteHead *)
    SPFreeMem(AbsExec,a,SIZE(ProcNode))
  ELSE
    WHILE (a^.next # NIL) AND (a^.next^.proc # p) DO
      a^.next:=a^.next^.next
    END;
    IF a^.next # NIL THEN
      b:=a^.next;
      a^.next:=a^.next^.next;
      SPFreeMem(AbsExec,b,SIZE(ProcNode));
    END;
  END;
END DeletePROC;

PROCEDURE CleanList(VAR l:ProcNodePtr);
VAR a: ProcNodePtr;
BEGIN
  WHILE (l # NIL) AND (l^.level>=currLevel) DO
    a:=l;
    l:=l^.next;
    SPFreeMem(AbsExec,a,SIZE(ProcNode))
  END
END CleanList;

PROCEDURE TermAll();
VAR a: ProcNodePtr;
BEGIN
  a:=termList;
  WHILE a # NIL DO
    WITH a^ DO
      a:=next;
      proc()
    END
  END
END TermAll;

PROCEDURE FindDebugProc():ProcNodePtr;
VAR a: ProcNodePtr;
BEGIN
  a:=debugList;
  WHILE (a # NIL) AND (a^.active) DO
    a:=a^.next
  END;
  RETURN a;
END FindDebugProc;

PROCEDURE Debug();
VAR a: ProcNodePtr;
BEGIN
  a:=FindDebugProc();
  IF a # NIL THEN
    WITH a^ DO
      active:=TRUE;
      proc();
      active:=FALSE
    END
  END
END Debug;

PROCEDURE Request(hText,text1,text2:ADDRESS; weiter: BOOLEAN);
VAR debugText, IntuiBase: ADDRESS;
    Height: INTEGER;
    oldCtrlC:BOOLEAN;
    oldTop,oldSP,stack:ADDRESS;

  PROCEDURE InitIntuiText(VAR i: IntuiText; x,y:INTEGER; text:ADDRESS);
  BEGIN
    WITH i DO
      frontPen:=0; backPen:=1;
      drawMode:=jam2;
      leftEdge:=x; topEdge:=y;
      iTextFont:=NIL; nextText:=NIL;
      iText:=text
    END
  END InitIntuiText;

BEGIN
  oldCtrlC:=detectCtrlC;
  detectCtrlC:=FALSE;
  stack:=SPAllocMem(AbsExec,1000H,MemReqSet{memClear});
  IF stack # NIL THEN
    oldSP:=REG(A7);
    oldTop:=stackTop;
    stackTop:=stack-256;
    SETREG(A7,stack+1000H);
  END;
  IntuiBase:=SPOpenLibrary(AbsExec,ADR('intuition.library'),0);
  IF IntuiBase # NIL THEN
    InitIntuiText(IText1,12,5,hText);
    Height:=54;
    IF text1 # NIL THEN
      InitIntuiText(IText2,12,16,text1);
      IText1.nextText:=ADR(IText2);
      Height:=65;
      IF text2 # NIL THEN
        InitIntuiText(IText3,12,27,text2);
	IText2.nextText:=ADR(IText3);
	Height:=70;
      END;
    END;
    InitIntuiText(IText4,6,3,ADR(" abbrechen "));
    IF weiter THEN
      IText4.iText:=ADR(" weiter ")
    END;
    IF FindDebugProc()=NIL THEN
      debugText:=NIL
    ELSE
      InitIntuiText(IText5,6,3,ADR(" debug "));
      debugText:=ADR(IText5)
    END;
    IF SPAutoRequest(IntuiBase,0,ADR(IText1),debugText,ADR(IText4),
		LONGSET{},LONGSET{},320,Height) # 0 THEN
      Debug
    END;
    SPCloseLibrary(AbsExec,IntuiBase);
  END; (* if intui *)
  IF stack # NIL THEN
    SETREG(A7,oldSP);
    SPFreeMem(AbsExec,stack,1000H);
    stackTop:=oldTop
  END;
  detectCtrlC:=oldCtrlC
END Request;

PROCEDURE ExceptProc();
VAR xx:BOOLEAN; oldD0:ADDRESS;
BEGIN
  oldD0:=REG(D0);
  IF detectCtrlC THEN
    Forbid;
    WITH myProcess^.task DO
      xx:=8 IN sigWait/sigRecvd; (* symmetrische Differenz EOR *)
    END;
    Permit;
    IF NOT xx THEN
      SPKillMsg(AbsExec,ADR(myProcess^.msgPort));
      Request(ADR(msLaufzeit),ADR("^C (Benutzer Unterbruch)"),NIL,FALSE);
      Terminate(currLevel)
    END;
  END;
  SETREG(D0,oldD0)
END ExceptProc;

PROCEDURE TrapHandler();
VAR string:ARRAY[0..31] OF CHAR;
BEGIN
  IF (errorFrame.trapNr>=0) AND (errorFrame.trapNr<=7) THEN
    errorFrame.text:=TrapMessages[errorFrame.trapNr]
  ELSIF errorFrame.trapNr=2EH THEN (* Trap #14 *)
    errorFrame.text:=RangeMessage
  ELSIF errorFrame.trapNr=2FH THEN (* Trap #15 *)
    errorFrame.text:=OverflowMessage
  ELSE
    RawDoFmt(ADR("Prozessor Trap (%d)"),ADR(errorFrame.trapNr),
    		ADR(rawDoProc),ADR(string));
    errorFrame.text:=ADR(string)
  END;
  Request(ADR(msLaufzeit),errorFrame.text,NIL,FALSE);
  Terminate(currLevel)
END TrapHandler;


PROCEDURE TrapProc();
VAR FramePtr: AdrPtr;
BEGIN
  FramePtr:=CAST(AdrPtr,REG(A5));
  WITH errorFrame DO
    mp:=FramePtr^;  (* altes A5 = Prozedurdaten *)
    INC(FramePtr,4);
    sb:=FramePtr^; (* altes A4 = Moduldaten *)
    INC(FramePtr,4);
    trapNr:=FramePtr^; (* von Exec dahingelegt *)
    error:=trap;
    IF (trapNr<=3) AND cpu68000 THEN (* stimmt!! *)
      INC(FramePtr,14)
    ELSE
      INC(FramePtr,6)
    END;
    pc:=FramePtr^;
    FramePtr^:=ADR(TrapHandler); (* Rcksprung dahin! *)
    SETREG(A7,CAST(ADDRESS,FramePtr)-2); (* vor Flags *)
    INLINE( RTE )
  END;
END TrapProc;

PROCEDURE OpenLibs(m:ModuleInfoPtr):BOOLEAN;
VAR a:AdrPtr;
BEGIN
  WHILE m^.id.type # 0 DO
    WITH m^ DO
      IF id.type=ORD(lib) THEN
        libPtr:=SPOpenLibrary(AbsExec,ADR(id.name),id.libVersion);
	IF libPtr # NIL THEN
	  WHILE fixup # NIL DO
	    a:=CAST(AdrPtr,fixup);
	    fixup:=fixup^;
	    a^:=libPtr (* in allen Modulen eintragen *)
	  END;
	ELSE
	  Request(ADR(msLaufzeit),ADR("Fehler beim ffnen der"),
	  			ADR(id.name),FALSE);
	  RETURN FALSE
	END;
      END;
    END;
    INC(m,SIZE(ModuleInfo));
  END;
  RETURN TRUE
END OpenLibs;

PROCEDURE CloseLibs(m:ModuleInfoPtr);
BEGIN
  WHILE m^.id.type # 0 DO
    WITH m^ DO
      IF (id.type=ORD(lib)) AND (libPtr # NIL) THEN
        SPCloseLibrary(AbsExec,libPtr)
      END;
    END;
    INC(m,SIZE(ModuleInfo))
  END;
END CloseLibs;

PROCEDURE Cleanup();
BEGIN
  CloseLibs(moduleInfo);
  IF wbStarted THEN
    SPForbid(AbsExec);
    SPReplyMsg(AbsExec,startupMsg)
  END;
END Cleanup;


PROCEDURE Startup(base,stack:LONGINT):LONGINT;
VAR main:PROC;
BEGIN
  dosCmdBuf  :=	REG(A0);
  dosCmdLen  :=	REG(D0);
  main 	     := CAST(PROC,REG(A1));
  moduleInfo := CAST(ModuleInfoPtr,REG(D7));
  rawDoProc  := 16C04E75H; (* MOVE.B D?,(A3)+  RTS *)
  returnVal  := 0;
  detectCtrlC:= TRUE;
  currLevel  := -1;
  stackSize  := stack;
  initialSP  := ADR(stack)-4;
  stackTop   := ADR(base)-stack+100H; (* ????? *)
  termList   := NIL;
  debugList  := NIL;
  termAllowed:= TRUE;
  myProcess  := CAST(ProcessPtr,SPFindTask(AbsExec,NIL));
  startupMsg := NIL;
  cpu68000   := FALSE;
  cpu68010   := FALSE;
  cpu68020   := FALSE;
  IF m68020 IN execBase^.attnFlags THEN
    cpu68020 := TRUE
  ELSIF m68010 IN execBase^.attnFlags THEN
    cpu68010 := TRUE
  ELSE
    cpu68000 := TRUE
  END;
  wbStarted  := (myProcess^.cli = NIL);
  IF wbStarted THEN
    SPWaitPort(AbsExec,ADR(myProcess^.msgPort));
    startupMsg := SPGetMsg(AbsExec,ADR(myProcess^.msgPort));
  END;
  IF OpenLibs(moduleInfo) THEN
    IF wbStarted THEN
      WBstartup := CAST(WBStartupPtr,startupMsg);
      SETREG(D0,CurrentDir(WBstartup^.argList^[0].lock));
    END;
    InitMessages;
    WITH myProcess^.task DO
      oldTrapProc:=trapCode;
      trapCode:=TrapProc;
      oldExceptProc:=exceptCode;
      exceptCode:=ExceptProc;
      SETREG(D0,SetExcept(LONGSET{12},LONGSET{12})); (* Ctrl-C abfangen *)
      Call(main);
      SETREG(D0,SetExcept(LONGSET{},LONGSET{12}));
      trapCode:=oldTrapProc;
      exceptCode:=oldExceptProc;
    END;
  ELSE
    returnVal:=20
  END;
  Cleanup;
  RETURN returnVal (* ans Dos zurck, Programm-Ende *)
END Startup;

PROCEDURE Call(p:PROC);
BEGIN
  IF currLevel<8 THEN
    INC(currLevel)
  ELSE
    SystemError(illCall)
  END;
  SPArr[currLevel]:=REG(A7);
  DEC(SPArr[currLevel],8); (* Platz fr A4, RTS *)
  INLINE(PUSHA4);
  SETREG(A4,0); (* warum? *)
  p(); (* ruft Prozedur auf, nach Terminate kommt sie hierher zurck *)
  INLINE(POPA4);
  SETREG(A5,REG(A7)); (* A5 wiederherstellen (Call hat keine Lokal-Variablen)*)
  IF termAllowed THEN
    termAllowed:=FALSE; (* damit bei Fehler keine Rekursion aufkommt *)
    TermAll; (* TermProcedures aufrufen *)
    termAllowed:=TRUE;
  END;
  CleanList(termList); (* alle Procs aus diesem Level lschen *)
  CleanList(debugList);
  DEC(currLevel)
END Call;

PROCEDURE Terminate(level:INTEGER);
BEGIN
  IF (level>=0) AND (level<=currLevel) THEN
    currLevel:=level
  ELSE
    currLevel:=0
  END;
  SETREG(A7,SPArr[currLevel]);
  INLINE(RTS)
END Terminate;

PROCEDURE SystemError(err{0}:SysErr);
VAR FramePtr: AdrPtr; ErrNr:INTEGER;
VAR
BEGIN
  FramePtr:=CAST(AdrPtr,REG(A5));
  errorFrame.mp:=FramePtr^;
  INC(FramePtr,4);
  errorFrame.sb:=FramePtr^;
  WITH errorFrame DO
    INC(FramePtr,4);
    pc:=FramePtr^;
    error:=system;
    sysErr:=err;
  END;
  ErrNr:=ORD(err); (* bis hierher hat sich err{D0} immer noch gehalten! *)
  IF ErrNr>4 THEN
    RawDoFmt(ADR(msSystemError),ADR(ErrNr),ADR(rawDoProc),ADR(rawDoString));
    errorFrame.text:=ADR(rawDoString)
  ELSE
    errorFrame.text:=SysMessages[err]
  END;
  Request(ADR(msLaufzeit),errorFrame.text,NIL,FALSE);
  returnVal:=ErrNr+20;
  Terminate(currLevel)
END SystemError;

PROCEDURE StkChk(need{0}:LONGINT);
BEGIN
  need:=need+REG(A7);
  IF need<stackTop THEN
    SystemError(stkOvl)
  END
END StkChk;

PROCEDURE Assert(condition:BOOLEAN; msg:ADDRESS);
VAR FramePtr:AdrPtr;
BEGIN
  IF NOT condition THEN
    FramePtr:=CAST(AdrPtr,REG(A5));
    WITH errorFrame DO
      mp:=FramePtr^;
      INC(FramePtr,4);
      sb:=FramePtr^;
      INC(FramePtr,4);
      pc:=FramePtr^;
      error:=assertion;
      text:=msg;
    END;
    Request(ADR(msAssert),msg,NIL,FALSE);
    Terminate(currLevel)
  END
END Assert;

PROCEDURE BreakPoint(msg:ADDRESS);
VAR FramePtr:AdrPtr;
BEGIN
  FramePtr:=CAST(AdrPtr,REG(A5));
  WITH errorFrame DO
    mp:=FramePtr^;
    INC(FramePtr,4);
    sb:=FramePtr^;
    INC(FramePtr,4);
    pc:=FramePtr^;
    error:=breakPoint;
    text:=msg;
  END;
  Request(ADR(msBreak),msg,NIL,TRUE); (* darf weitermachen *)
END BreakPoint;

PROCEDURE Error(header,body: ADDRESS);
VAR FramePtr:AdrPtr;
BEGIN
  FramePtr:=CAST(AdrPtr,REG(A5));
  WITH errorFrame DO
    mp:=FramePtr^;
    INC(FramePtr,4);
    sb:=FramePtr^;
    INC(FramePtr,4);
    pc:=FramePtr^;
    error:=explicit;
    text:=header;
    text2:=body
  END;
  Request(ADR(msLaufzeit),header,body,FALSE);
  Terminate(currLevel)
END Error;

PROCEDURE CurrentLevel():INTEGER;
BEGIN
  RETURN currLevel
END CurrentLevel;

PROCEDURE DebugProcedure(debugger:PROC);
BEGIN
  AddPROC(debugList,debugger)
END DebugProcedure;

PROCEDURE RemoveDebugProc(debugger:PROC);
BEGIN
  DeletePROC(debugList,debugger)
END RemoveDebugProc;

PROCEDURE RemoveTermProc(p:PROC);
BEGIN
  DeletePROC(termList,p)
END RemoveTermProc;

PROCEDURE TermProcedure(p:PROC);
BEGIN
  AddPROC(termList,p)
END TermProcedure;

(* $F-  fr alle INLINEs Rckgabe: D0:Rest, D1:Quotient *)
(* $E- *)
PROCEDURE Mulu32(x{D0},y{D1}: LONGINT): LONGINT;
BEGIN
INLINE(0,0)
END Mulu32;

(* $E- *)
PROCEDURE Divu32(x{D0},y{D1}: LONGINT): LONGINT; (* warum nicht LONGCARD ?? *)
BEGIN
INLINE(0,0)
END Divu32;

(* $E- *)
PROCEDURE Muls32(x{D0},y{D1}: LONGINT): LONGINT;
BEGIN
INLINE(0,0)
END Muls32;

(* $E- *)
PROCEDURE Divs32(x{D0},y{D1}: LONGINT): LONGINT;
BEGIN
  INLINE(0,0);
  SETREG(D0,Divu32(x,y));
  INLINE(0,0)
END Divs32;


END Arts.mod
