MODULE AverageAge;   (* Calculate average age *)

  (* From the book "Modula-2  A Seafarer's Manual and Shipyard Guide" *)
  (* Page 67   adapted "Amiga M2Modula-2"   04 Mar 1988 *)

FROM InOut IMPORT WriteLn,
                  WriteString,
                  ReadCard;
FROM RealInOut IMPORT WriteReal;

VAR
  i : CARDINAL;
  average : REAL;
  CrewAge : ARRAY [1..25] OF CARDINAL;
  
BEGIN
  WriteLn;
  WriteString ("Enter crew ages: ");
  WriteLn;
  
  FOR i := 1 TO 25 BY 1 DO
    ReadCard (CrewAge[i]);   (* get age from keyboard *)
    WriteLn;
  END;
  
  average := 0.0;
  FOR i:= 1 TO 25 BY 1 DO   (* sum ages *)
    average := average + FLOAT (CrewAge[i]);
  END;
  
  average := average / 25.0;   (* calculate average *)
  WriteLn;
  WriteString ("Average age = ");
  WriteReal (average,10,2);
  WriteLn;
  
END AverageAge.

