MODULE C3P4;   (* Chapter 3  Problem 4 *)
	       (* Converts Celsius to Fahrenheit and vice versa *)

   (* From the book "Modula-2  A Seafarer's Manual and Shipyard Guide" *)
   (* Page 78   adapted "M2Amiga Modula-2"   04 Mar 1988 *)

FROM InOut IMPORT Read,
                  ReadInt,
                  ReadString,
                  WriteInt,
                  WriteString,
                  WriteLn;
FROM RealInOut IMPORT WriteReal;
                  
VAR
  dummy : ARRAY [0..80] OF CHAR;   (* for M2Amiga - Read works not right *)
  joice : CHAR;
  again : BOOLEAN;
  counter,			   (* number of conversions processed *)
  Celsius,
  Fahrenheit : INTEGER;
  CelsiusResult,
  FahrenheitResult : REAL;
  
BEGIN
  counter := 0;
  again := TRUE;
  REPEAT
    WriteString ("What do you like?");	(* Built up menu *)
    WriteLn; WriteLn;
    WriteString ("   (C) Convert Celsius to Fahrenheit");
    WriteLn;
    WriteString ("   (F) Convert Fahrenheit to Celsius");
    WriteLn;
    WriteString ("   (Q) Quit?");
    WriteLn; WriteLn;
    Read (joice);
    ReadString (dummy);
    joice := CAP(joice);
    CASE joice OF
      "C" : WriteString ("Convert Celsius to Fahrenheit:");
            WriteLn; WriteLn; WriteLn;
            WriteString ("Enter integer value: ");
            ReadInt (Celsius);
            FahrenheitResult := (1.8 * FLOAT(Celsius)) + 32.0;
            WriteLn;
            WriteInt (Celsius,4);
            WriteString (" degree Celsius are equal to ");
            WriteReal (FahrenheitResult,7,2);
            WriteString (" degree Fahrenheit");
            WriteLn; WriteLn; WriteLn;
            INC (counter);
            |
      "F" : WriteString ("Convert Fahrenheit to Celsius:");
            WriteLn; WriteLn; WriteLn;
            WriteString ("Enter integer value: ");
            ReadInt (Fahrenheit);
            CelsiusResult := (FLOAT(Fahrenheit) - 32.0) / 1.8;
            WriteLn;
            WriteInt (Fahrenheit,4);
            WriteString (" degree Fahrenheit are equal to ");
            WriteReal (CelsiusResult,7,2);
            WriteString (" degree Celsius");
            WriteLn; WriteLn; WriteLn;
            INC (counter);
            |
      "Q" : again := FALSE;
            WriteInt (counter,6);
            WriteString (" conversions processed!");
            WriteLn; WriteLn; 
    ELSE
      WriteString ("Invalid Entry!  Try again!");
      WriteLn; WriteLn;
    END;   (* CASE *)
  UNTIL NOT again;
  
END C3P4.mod
